import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { IgxFinancialIndicatorComponent } from "./igx-financial-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { UltimateOscillatorIndicator } from "./UltimateOscillatorIndicator";
/**
 * Represents a IgxDataChartComponent Ultimate Oscillator indicator series.
 * Default required members: High, Low, Close
*
* You can use the `IgxUltimateOscillatorIndicatorComponent` which represents a IgxDataChartComponent Ultimate Oscillator indicator series.
*
* ```html
* <igx-data-chart
* 	#chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-ultimate-oscillator-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-ultimate-oscillator-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxUltimateOscillatorIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
export var IgxUltimateOscillatorIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent; }) }];
var IgxUltimateOscillatorIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxUltimateOscillatorIndicatorComponent, _super);
    function IgxUltimateOscillatorIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxUltimateOscillatorIndicatorComponent_1 = IgxUltimateOscillatorIndicatorComponent;
    IgxUltimateOscillatorIndicatorComponent.prototype.createImplementation = function () {
        return new UltimateOscillatorIndicator();
    };
    Object.defineProperty(IgxUltimateOscillatorIndicatorComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    var IgxUltimateOscillatorIndicatorComponent_1;
    IgxUltimateOscillatorIndicatorComponent = IgxUltimateOscillatorIndicatorComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-ultimate-oscillator-indicator',
            template: "",
            providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent_1; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent_1; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent_1; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxUltimateOscillatorIndicatorComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxUltimateOscillatorIndicatorComponent);
    return IgxUltimateOscillatorIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxUltimateOscillatorIndicatorComponent };
//# sourceMappingURL=igx-ultimate-oscillator-indicator-component.js.map