import { Type } from '@angular/core';
import { BrushSelectionMode } from "./BrushSelectionMode";
import { IgxBrushScaleComponent } from "./igx-brush-scale-component";
import { CustomPaletteBrushScale } from "./CustomPaletteBrushScale";
/**
 * Represents a brush scale that uses index-based brush selection mode.
*/
export declare const IgxCustomPaletteBrushScaleComponent_PROVIDERS: {
    provide: typeof IgxBrushScaleComponent;
    useExisting: Type<any>;
}[];
export declare class IgxCustomPaletteBrushScaleComponent extends IgxBrushScaleComponent {
    protected createImplementation(): CustomPaletteBrushScale;
    /**
                                 * @hidden
                                 */
    readonly i: CustomPaletteBrushScale;
    constructor();
    /**
     * Gets or sets the brush selection mode.
    */
    brushSelectionMode: BrushSelectionMode;
    /**
     * Checks if this scale is ready for useage with a series
    */
    readonly isReady: boolean;
    getBrush1(index: number, total: number): string;
}
