import { ILegendSeries } from "igniteui-angular-core";
import { ILegendOwner } from "igniteui-angular-core";
import { LegendMouseButtonEventArgs as LegendMouseButtonEventArgs_internal } from "./LegendMouseButtonEventArgs";
/**
 * Provides data for legend mouse button related events.
*/
export declare class IgxLegendMouseButtonEventArgs {
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: LegendMouseButtonEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets a value that indicates the present state of the event handling for a routed
     * event as it travels the route.
     * ChartMouseButton events are not routed events; setting this property effects the underlying
     * MouseButtonEvent.
    */
    handled: boolean;
    /**
     * Gets a reference to the object that raised the event.
    */
    readonly originalSource: any;
    /**
     * Gets the ItemsSource item associated with the current event.
    */
    item: any;
    /**
     * Gets the series associated with the current event.
    */
    series: ILegendSeries;
    /**
     * Gets the Chart associated with the current event.
    */
    chart: ILegendOwner;
    /**
     * The legend item that was the target of the mouse event.
    */
    legendItem: any;
    /**
     * Provides a human readable description of the mouse button event.
    
    */
    toString(): string;
}
