import { Type } from '@angular/core';
import { UnknownValuePlotting } from "igniteui-angular-core";
import { IgxAnchoredRadialSeriesComponent } from "./igx-anchored-radial-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { RadialAreaSeries } from "./RadialAreaSeries";
/**
 * Represents a IgxDataChartComponent radial area series.
*/
export declare const IgxRadialAreaSeriesComponent_PROVIDERS: ({
    provide: typeof IgxMarkerSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxRadialAreaSeriesComponent extends IgxAnchoredRadialSeriesComponent {
    protected createImplementation(): RadialAreaSeries;
    /**
                                 * @hidden
                                 */
    readonly i: RadialAreaSeries;
    constructor();
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    unknownValuePlotting: UnknownValuePlotting;
}
